# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.AddMatterPermissionsRequest do
  @moduledoc """
  Add an account with the permission specified. The role cannot be owner. If an account already has a role in the matter, the existing role is overwritten.

  ## Attributes

  *   `ccMe` (*type:* `boolean()`, *default:* `nil`) - Only relevant if **sendEmails** is **true**. To CC the requestor in the email message, set to **true**. To not CC requestor, set to **false**.
  *   `matterPermission` (*type:* `GoogleApi.Vault.V1.Model.MatterPermission.t`, *default:* `nil`) - The account and its role to add.
  *   `sendEmails` (*type:* `boolean()`, *default:* `nil`) - To send a notification email to the added account, set to **true**. To not send a notification email, set to **false**.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ccMe => boolean() | nil,
          :matterPermission => GoogleApi.Vault.V1.Model.MatterPermission.t() | nil,
          :sendEmails => boolean() | nil
        }

  field(:ccMe)
  field(:matterPermission, as: GoogleApi.Vault.V1.Model.MatterPermission)
  field(:sendEmails)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.AddMatterPermissionsRequest do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.AddMatterPermissionsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.AddMatterPermissionsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
