# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.CountArtifactsMetadata do
  @moduledoc """
  Long running operation metadata for CountArtifacts.

  ## Attributes

  *   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - End time of count operation. Available when operation is done.
  *   `matterId` (*type:* `String.t`, *default:* `nil`) - The matter ID of the associated matter.
  *   `query` (*type:* `GoogleApi.Vault.V1.Model.Query.t`, *default:* `nil`) - The search query from the request.
  *   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Creation time of count operation.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :endTime => DateTime.t() | nil,
          :matterId => String.t() | nil,
          :query => GoogleApi.Vault.V1.Model.Query.t() | nil,
          :startTime => DateTime.t() | nil
        }

  field(:endTime, as: DateTime)
  field(:matterId)
  field(:query, as: GoogleApi.Vault.V1.Model.Query)
  field(:startTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.CountArtifactsMetadata do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.CountArtifactsMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.CountArtifactsMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
