# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.DriveOptions do
  @moduledoc """
  Additional options for Drive search

  ## Attributes

  *   `clientSideEncryptedOption` (*type:* `String.t`, *default:* `nil`) - Set whether the results include only content encrypted with [Google Workspace Client-side encryption](https://support.google.com/a?p=cse_ov) content, only unencrypted content, or both. Defaults to both. Currently supported for Drive.
  *   `includeSharedDrives` (*type:* `boolean()`, *default:* `nil`) - Set to **true** to include shared drives.
  *   `includeTeamDrives` (*type:* `boolean()`, *default:* `nil`) - Set to true to include Team Drive.
  *   `versionDate` (*type:* `DateTime.t`, *default:* `nil`) - Search the current version of the Drive file, but export the contents of the last version saved before 12:00 AM UTC on the specified date. Enter the date in UTC.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :clientSideEncryptedOption => String.t() | nil,
          :includeSharedDrives => boolean() | nil,
          :includeTeamDrives => boolean() | nil,
          :versionDate => DateTime.t() | nil
        }

  field(:clientSideEncryptedOption)
  field(:includeSharedDrives)
  field(:includeTeamDrives)
  field(:versionDate, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.DriveOptions do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.DriveOptions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.DriveOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
