# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.ExportOptions do
  @moduledoc """
  Additional options for exports

  ## Attributes

  *   `calendarOptions` (*type:* `GoogleApi.Vault.V1.Model.CalendarExportOptions.t`, *default:* `nil`) - Option available for Calendar export.
  *   `driveOptions` (*type:* `GoogleApi.Vault.V1.Model.DriveExportOptions.t`, *default:* `nil`) - Options for Drive exports.
  *   `groupsOptions` (*type:* `GoogleApi.Vault.V1.Model.GroupsExportOptions.t`, *default:* `nil`) - Options for Groups exports.
  *   `hangoutsChatOptions` (*type:* `GoogleApi.Vault.V1.Model.HangoutsChatExportOptions.t`, *default:* `nil`) - Options for Chat exports.
  *   `mailOptions` (*type:* `GoogleApi.Vault.V1.Model.MailExportOptions.t`, *default:* `nil`) - Options for Gmail exports.
  *   `region` (*type:* `String.t`, *default:* `nil`) - The requested data region for the export.
  *   `voiceOptions` (*type:* `GoogleApi.Vault.V1.Model.VoiceExportOptions.t`, *default:* `nil`) - Options for Voice exports.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :calendarOptions => GoogleApi.Vault.V1.Model.CalendarExportOptions.t() | nil,
          :driveOptions => GoogleApi.Vault.V1.Model.DriveExportOptions.t() | nil,
          :groupsOptions => GoogleApi.Vault.V1.Model.GroupsExportOptions.t() | nil,
          :hangoutsChatOptions => GoogleApi.Vault.V1.Model.HangoutsChatExportOptions.t() | nil,
          :mailOptions => GoogleApi.Vault.V1.Model.MailExportOptions.t() | nil,
          :region => String.t() | nil,
          :voiceOptions => GoogleApi.Vault.V1.Model.VoiceExportOptions.t() | nil
        }

  field(:calendarOptions, as: GoogleApi.Vault.V1.Model.CalendarExportOptions)
  field(:driveOptions, as: GoogleApi.Vault.V1.Model.DriveExportOptions)
  field(:groupsOptions, as: GoogleApi.Vault.V1.Model.GroupsExportOptions)
  field(:hangoutsChatOptions, as: GoogleApi.Vault.V1.Model.HangoutsChatExportOptions)
  field(:mailOptions, as: GoogleApi.Vault.V1.Model.MailExportOptions)
  field(:region)
  field(:voiceOptions, as: GoogleApi.Vault.V1.Model.VoiceExportOptions)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.ExportOptions do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.ExportOptions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.ExportOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
