# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.HeldOrgUnit do
  @moduledoc """
  The organizational unit covered by a hold. This structure is immutable.

  ## Attributes

  *   `holdTime` (*type:* `DateTime.t`, *default:* `nil`) - When the organizational unit was put on hold. This property is immutable.
  *   `orgUnitId` (*type:* `String.t`, *default:* `nil`) - The organizational unit's immutable ID as provided by the [Admin SDK](https://developers.google.com/admin-sdk/).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :holdTime => DateTime.t() | nil,
          :orgUnitId => String.t() | nil
        }

  field(:holdTime, as: DateTime)
  field(:orgUnitId)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.HeldOrgUnit do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.HeldOrgUnit.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.HeldOrgUnit do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
