# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.HeldVoiceQuery do
  @moduledoc """
  Options for Voice holds.

  ## Attributes

  *   `coveredData` (*type:* `list(String.t)`, *default:* `nil`) - A list of data types covered by the hold. Should be non-empty. Order does not matter and duplicates are ignored.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :coveredData => list(String.t()) | nil
        }

  field(:coveredData, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.HeldVoiceQuery do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.HeldVoiceQuery.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.HeldVoiceQuery do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
