# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.ListHoldsResponse do
  @moduledoc """
  The holds for a matter.

  ## Attributes

  *   `holds` (*type:* `list(GoogleApi.Vault.V1.Model.Hold.t)`, *default:* `nil`) - The list of holds.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Page token to retrieve the next page of results in the list. If this is empty, then there are no more holds to list.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :holds => list(GoogleApi.Vault.V1.Model.Hold.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:holds, as: GoogleApi.Vault.V1.Model.Hold, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.ListHoldsResponse do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.ListHoldsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.ListHoldsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
