# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Vault.V1.Model.MatterPermission do
  @moduledoc """
  Users can be matter owners or collaborators. Each matter has only one owner. All others users who can access the matter are collaborators. When an account is purged, its corresponding MatterPermission resources cease to exist.

  ## Attributes

  *   `accountId` (*type:* `String.t`, *default:* `nil`) - The account ID, as provided by the [Admin SDK](https://developers.google.com/admin-sdk/).
  *   `role` (*type:* `String.t`, *default:* `nil`) - The user's role for the matter.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :accountId => String.t() | nil,
          :role => String.t() | nil
        }

  field(:accountId)
  field(:role)
end

defimpl Poison.Decoder, for: GoogleApi.Vault.V1.Model.MatterPermission do
  def decode(value, options) do
    GoogleApi.Vault.V1.Model.MatterPermission.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Vault.V1.Model.MatterPermission do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
